"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_1 = require("@storybook/react");
var Autocomplete_1 = require("./Autocomplete");
var pure_1 = require("../../utils/pure");
var Demo_1 = require("../demo/Demo");
var css = require("./Autocomplete.page.styl");
var data = Array.from(new Array(20).keys()).map(function (v) { return "" + v; });
var filter = function (value) { return function (item, index) { return item.indexOf(value) !== -1; }; };
var theme = {
    Input: {
        container: css.autocomplete__input,
    },
    Popover: {
        container: css.autocomplete__popover,
    },
    MenuItem: {
        Highlight: {
            mark: css.highlight__mark,
        },
    },
};
var AutocompletePage = /** @class */ (function (_super) {
    tslib_1.__extends(AutocompletePage, _super);
    function AutocompletePage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: '',
        };
        _this.onValueChange = function (value) {
            _this.setState({
                value: value,
            });
        };
        return _this;
    }
    AutocompletePage.prototype.render = function () {
        return (React.createElement(Demo_1.default, null,
            React.createElement(Autocomplete_1.Autocomplete, { data: data, filter: filter, theme: theme, value: this.state.value, onValueChange: this.onValueChange })));
    };
    AutocompletePage = tslib_1.__decorate([
        pure_1.PURE
    ], AutocompletePage);
    return AutocompletePage;
}(React.Component));
react_1.storiesOf('Autocomplete', module).add('Default', function () {
    return (React.createElement(Demo_1.default, null,
        React.createElement(AutocompletePage, null)));
});
//# sourceMappingURL=Autocomplete.page.js.map