"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_1 = require("@storybook/react");
var addon_actions_1 = require("@storybook/addon-actions");
var add_icon_1 = require("../../icons/add-icon");
var calendar_icon_1 = require("../../icons/calendar-icon");
var decrease_icon_1 = require("../../icons/decrease-icon");
var small_cross_icon_1 = require("../../icons/small-cross-icon");
var DateInput_1 = require("./DateInput");
var Control_1 = require("../Control/Control");
var Demo_1 = require("../demo/Demo");
var Button_1 = require("../Button/Button");
var ToggleButtons_1 = require("../ToggleButtons/ToggleButtons");
var Option_1 = require("fp-ts/lib/Option");
var DateInput_model_1 = require("./DateInput.model");
var react_dom_1 = require("react-dom");
var Stateful = Control_1.stateful()(DateInput_1.DateInput);
var onChange = function (value) { return addon_actions_1.action('change')(value); };
var onClear = function () { return addon_actions_1.action('clear')(); };
var Calendar = function (props) {
    var onChange = function () { return props.onValueChange && props.onValueChange(new Date()); };
    return (React.createElement("div", { onMouseDown: props.onMouseDown },
        "calendar",
        React.createElement(Button_1.Button, { onClick: onChange }, "click me")));
};
var DateInputPage = /** @class */ (function (_super) {
    tslib_1.__extends(DateInputPage, _super);
    function DateInputPage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.endDateInput = null;
        _this.state = {
            value: { day: Option_1.some(1), month: Option_1.some(1), year: Option_1.some(2018) },
            dateFormatType: DateInput_model_1.DateFormatType.DMY,
            isStartDateFocused: false,
            isEndDateFocused: false,
        };
        _this.onStartDateFocus = function () { return _this.setState({ isStartDateFocused: true }); };
        _this.onEndDateFocus = function () { return _this.setState({ isEndDateFocused: true }); };
        _this.onStartDateBlur = function () { return _this.setState({ isStartDateFocused: false }); };
        _this.onEndDateBlur = function () { return _this.setState({ isEndDateFocused: false }); };
        _this.onKeyPress = function (e) {
            if (e.charCode === 13) {
                if (_this.state.isStartDateFocused && _this.endDateInput) {
                    _this.onFocus(_this.endDateInput);
                }
                if (_this.state.isEndDateFocused && _this.endDateInput) {
                    _this.onBlur(_this.endDateInput);
                }
            }
        };
        _this.onFocus = function (reference) {
            var element = react_dom_1.findDOMNode(reference);
            if (element instanceof HTMLElement) {
                element.focus();
            }
        };
        _this.onBlur = function (reference) {
            var element = react_dom_1.findDOMNode(reference);
            if (element instanceof HTMLElement) {
                element.blur();
            }
        };
        _this.getEndDateRef = function (input) {
            _this.endDateInput = input;
        };
        _this.onControlledManualClear = function () {
            _this.setState({
                value: { day: Option_1.none, month: Option_1.none, year: Option_1.none },
            });
        };
        _this.onControlledClear = function () {
            _this.setState({
                value: { day: Option_1.none, month: Option_1.none, year: Option_1.none },
            });
        };
        _this.onControlledChange = function (value) {
            _this.setState({
                value: value,
            });
        };
        _this.onToggleChange = function (index) {
            switch (index) {
                case 0: {
                    _this.setState({
                        dateFormatType: DateInput_model_1.DateFormatType.DMY,
                    });
                    break;
                }
                case 1: {
                    _this.setState({
                        dateFormatType: DateInput_model_1.DateFormatType.MDY,
                    });
                    break;
                }
            }
        };
        return _this;
    }
    DateInputPage.prototype.render = function () {
        var _this = this;
        var _a = this.props, isDisabled = _a.isDisabled, error = _a.error;
        var value = this.state.value;
        return (React.createElement(Demo_1.Demo, null,
            React.createElement("div", null,
                "DateFormatType",
                React.createElement(ToggleButtons_1.ToggleButtons, { toggleIndex: this.getToggleIndex(), isVertical: true, onChange: this.onToggleChange },
                    React.createElement(Button_1.Button, null, "DD/MM/YYYY"),
                    React.createElement(Button_1.Button, null, "MM/DD/YYYY"))),
            React.createElement("input", { type: "date", id: "date", disabled: isDisabled }),
            React.createElement("section", null,
                React.createElement("h1", null, "Controlled"),
                React.createElement(DateInput_1.DateInput, { dateFormatType: this.state.dateFormatType, onValueChange: this.onControlledChange, clearIcon: React.createElement(small_cross_icon_1.SmallCrossIcon, null), incrementIcon: React.createElement(add_icon_1.AddIcon, null), decrementIcon: React.createElement(decrease_icon_1.DecreaseIcon, null), onClear: this.onControlledClear, error: error, value: value }),
                React.createElement(Button_1.Button, { onClick: this.onControlledManualClear }, "Clear")),
            React.createElement("section", null,
                React.createElement("h1", null, "without Calendar"),
                React.createElement(Stateful, { dateFormatType: this.state.dateFormatType, decrementIcon: React.createElement(decrease_icon_1.DecreaseIcon, null), isDisabled: isDisabled, incrementIcon: React.createElement(add_icon_1.AddIcon, null), clearIcon: React.createElement(small_cross_icon_1.SmallCrossIcon, null), error: error, onValueChange: onChange, onClear: onClear, defaultValue: { day: Option_1.none, month: Option_1.none, year: Option_1.none } }),
                React.createElement(Stateful, { dateFormatType: this.state.dateFormatType, decrementIcon: React.createElement(decrease_icon_1.DecreaseIcon, null), isDisabled: isDisabled, incrementIcon: React.createElement(add_icon_1.AddIcon, null), clearIcon: React.createElement(small_cross_icon_1.SmallCrossIcon, null), onValueChange: onChange, error: error, onClear: onClear, defaultValue: { day: Option_1.none, month: Option_1.none, year: Option_1.none } }),
                React.createElement(Stateful, { dateFormatType: this.state.dateFormatType, decrementIcon: React.createElement(decrease_icon_1.DecreaseIcon, null), isDisabled: isDisabled, incrementIcon: React.createElement(add_icon_1.AddIcon, null), clearIcon: React.createElement(small_cross_icon_1.SmallCrossIcon, null), onValueChange: onChange, error: error, onClear: onClear, defaultValue: { day: Option_1.none, month: Option_1.none, year: Option_1.none } })),
            React.createElement("section", null,
                React.createElement("h1", null, "with calendar"),
                React.createElement(Stateful, { dateFormatType: this.state.dateFormatType, decrementIcon: React.createElement(decrease_icon_1.DecreaseIcon, null), incrementIcon: React.createElement(add_icon_1.AddIcon, null), isDisabled: isDisabled, error: error, clearIcon: React.createElement(small_cross_icon_1.SmallCrossIcon, null), calendarIcon: React.createElement(calendar_icon_1.CalendarIcon, null), onValueChange: onChange, onClear: onClear, Calendar: Calendar, defaultValue: { day: Option_1.none, month: Option_1.none, year: Option_1.none } }),
                React.createElement(Stateful, { dateFormatType: this.state.dateFormatType, decrementIcon: React.createElement(decrease_icon_1.DecreaseIcon, null), incrementIcon: React.createElement(add_icon_1.AddIcon, null), isDisabled: isDisabled, clearIcon: React.createElement(small_cross_icon_1.SmallCrossIcon, null), error: error, calendarIcon: React.createElement(calendar_icon_1.CalendarIcon, null), onValueChange: onChange, onClear: onClear, Calendar: Calendar, target: this.target, defaultValue: { day: Option_1.none, month: Option_1.none, year: Option_1.none } })),
            React.createElement("section", null,
                React.createElement("h1", null, "calendar output target"),
                React.createElement("div", { ref: function (el) { return (_this.target = el); } })),
            React.createElement("section", null,
                React.createElement("h1", null, "Date range"),
                React.createElement("p", null, "Example how to combine two DateInputs and test case with focus/blur inputs by press enter"),
                React.createElement("div", { onKeyPress: this.onKeyPress },
                    React.createElement(Stateful, { dateFormatType: this.state.dateFormatType, onValueChange: onChange, clearIcon: React.createElement(small_cross_icon_1.SmallCrossIcon, null), incrementIcon: React.createElement(add_icon_1.AddIcon, null), decrementIcon: React.createElement(decrease_icon_1.DecreaseIcon, null), onClear: onClear, error: error, defaultValue: { day: Option_1.none, month: Option_1.none, year: Option_1.none }, onFocus: this.onStartDateFocus, onBlur: this.onStartDateBlur, isDisabled: isDisabled }),
                    React.createElement(Stateful, { dateFormatType: this.state.dateFormatType, onValueChange: onChange, clearIcon: React.createElement(small_cross_icon_1.SmallCrossIcon, null), incrementIcon: React.createElement(add_icon_1.AddIcon, null), decrementIcon: React.createElement(decrease_icon_1.DecreaseIcon, null), onClear: onClear, error: error, defaultValue: { day: Option_1.none, month: Option_1.none, year: Option_1.none }, innerRef: this.getEndDateRef, onFocus: this.onEndDateFocus, onBlur: this.onEndDateBlur, isDisabled: isDisabled })))));
    };
    DateInputPage.prototype.getToggleIndex = function () {
        switch (this.state.dateFormatType) {
            case DateInput_model_1.DateFormatType.DMY: {
                return 0;
            }
            case DateInput_model_1.DateFormatType.MDY: {
                return 1;
            }
        }
    };
    return DateInputPage;
}(React.Component));
react_1.storiesOf('DateInput', module)
    .add('default', function () { return React.createElement(DateInputPage, null); })
    .add('disabled', function () { return React.createElement(DateInputPage, { isDisabled: true }); })
    .add('invalid', function () { return React.createElement(DateInputPage, { error: true }); });
//# sourceMappingURL=DateInput.page.js.map