import { ComponentClass, ComponentType, MouseEventHandler, ReactNode } from 'react';
import { TPopoverProps } from '../Popover/Popover';
import { WithInnerRef } from '../../utils/typings';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
import { TControlProps } from '../Control/Control';
export declare const DROPDOWN: symbol;
export declare type TAnchorProps = WithInnerRef<{
    onClick: MouseEventHandler<Element>;
    children: ReactNode;
}>;
export declare type TFullDropdownProps = TControlProps<boolean | undefined, 'isOpened', 'onToggle'> & {
    Anchor: ComponentType<TAnchorProps>;
    Popover: ComponentType<TPopoverProps>;
    theme: {
        Popover?: TPopoverProps['theme'];
    };
    hasArrow?: boolean;
};
export declare type TDropdownProps = PartialKeys<TFullDropdownProps, 'theme' | 'Popover'>;
export declare const Dropdown: ComponentClass<TDropdownProps>;
