"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_1 = require("@storybook/react");
var Demo_1 = require("../demo/Demo");
var Dropdown_1 = require("./Dropdown");
var react_2 = require("react");
var Button_1 = require("../Button/Button");
var pure_1 = require("../../utils/pure");
var Control_1 = require("../Control/Control");
var StatefulDropdown = Control_1.stateful('isOpened', 'onToggle')(Dropdown_1.Dropdown);
var AnchorClass = /** @class */ (function (_super) {
    tslib_1.__extends(AnchorClass, _super);
    function AnchorClass() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AnchorClass.prototype.render = function () {
        var _a = this.props, innerRef = _a.innerRef, children = _a.children, onClick = _a.onClick;
        console.log('rendering anchor class');
        return (React.createElement(Button_1.Button, { ref: innerRef, onClick: onClick },
            "Class Anchor",
            children));
    };
    AnchorClass = tslib_1.__decorate([
        pure_1.PURE
    ], AnchorClass);
    return AnchorClass;
}(react_2.Component));
var AnchorSFC = function (props) {
    var innerRef = props.innerRef, children = props.children, onClick = props.onClick;
    return (React.createElement(Button_1.Button, { ref: innerRef, onClick: onClick },
        "SFC Anchor",
        children));
};
react_1.storiesOf('Dropdown', module)
    .add('with class Anchor', function () { return (React.createElement(Demo_1.Demo, null,
    React.createElement(StatefulDropdown, { defaultValue: undefined, Anchor: AnchorClass },
        React.createElement("div", null, "hi!")))); })
    .add('with SFC Anchor', function () { return (React.createElement(Demo_1.Demo, null,
    React.createElement(StatefulDropdown, { defaultValue: undefined, Anchor: AnchorSFC, onToggle: console.log.bind(console) }, "hi"))); })
    .add('with force close', function () { return (React.createElement(Demo_1.Demo, null,
    React.createElement(DropdownPage, null))); });
var DropdownPage = /** @class */ (function (_super) {
    tslib_1.__extends(DropdownPage, _super);
    function DropdownPage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onForceCloseClick = function () {
            _this.forceClose();
        };
        _this.getForceClose = function (close) {
            _this.forceClose = close;
        };
        return _this;
    }
    DropdownPage.prototype.render = function () {
        return (React.createElement("div", null,
            React.createElement(StatefulDropdown, { defaultValue: undefined, Anchor: AnchorClass },
                React.createElement(Button_1.Button, { onClick: this.onForceCloseClick }, "Force close"))));
    };
    return DropdownPage;
}(react_2.Component));
//# sourceMappingURL=Dropdown.page.js.map