"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_1 = require("@storybook/react");
var Demo_1 = require("../demo/Demo");
var pure_1 = require("../../utils/pure");
var Grid_1 = require("./Grid");
var css = require("./Grid.demo.styl");
var gridTheme = {
    container: css.container,
    gridBody: css.gridBody,
    gridHead: css.gridHead,
    gridHead_paddedForScrollbar: css.gridHead_paddedForScrollbar,
    gridCell__placeholder: css.gridCell__placeholder,
    gridCell__content: css.gridCell__content,
    gridCell__content_left: css.gridCell__content_left,
    gridCell__content_center: css.gridCell__content_center,
    gridCell__content_right: css.gridCell__content_right,
    horizontal_scrollbar__bar: css.horizontal_scrollbar__bar,
    vertical_scrollbar__bar: css.vertical_scrollbar__bar,
};
var GridPage = /** @class */ (function (_super) {
    tslib_1.__extends(GridPage, _super);
    function GridPage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isLong: true,
            counter: 0,
        };
        return _this;
    }
    GridPage.prototype.componentDidMount = function () {
        // this._interval1 = setInterval(() => {
        // 	this.setState({
        // 		isLong: !this.state.isLong
        // 	});
        // }, 3000);
        var _this = this;
        this._interval2 = setInterval(function () {
            _this.setState({
                counter: _this.state.counter + 1,
            });
        }, 1000);
    };
    GridPage.prototype.componentWillUnmount = function () {
        clearTimeout(this._interval1);
        clearInterval(this._interval2);
    };
    GridPage.prototype.render = function () {
        var _this = this;
        return (React.createElement(Demo_1.default, null,
            React.createElement(Grid_1.Grid, { theme: gridTheme },
                React.createElement(Grid_1.GridHead, { theme: gridTheme },
                    React.createElement(Grid_1.GridRow, null,
                        React.createElement(Grid_1.GridCell, { align: Grid_1.GridCellAlignment.LEFT, theme: gridTheme }, "1"),
                        React.createElement(Grid_1.GridCell, { theme: gridTheme }, this.state.isLong ? '2_______________________________________' : '2'),
                        React.createElement(Grid_1.GridCell, { theme: gridTheme }, "3"))),
                React.createElement(Grid_1.GridBody, { theme: gridTheme }, Array.from(new Array(20), function () { return 0; }).map(function (_, i) { return (React.createElement(Grid_1.GridRow, { key: i },
                    React.createElement(Grid_1.GridCell, { align: Grid_1.GridCellAlignment.LEFT, theme: gridTheme }, _this.state.counter),
                    React.createElement(Grid_1.GridCell, { theme: gridTheme }, "2"),
                    React.createElement(Grid_1.GridCell, { theme: gridTheme }, "3_______________________________________"))); })))));
    };
    GridPage = tslib_1.__decorate([
        pure_1.PURE
    ], GridPage);
    return GridPage;
}(React.Component));
react_1.storiesOf('Grid', module).add('default', function () { return React.createElement(GridPage, null); });
//# sourceMappingURL=Grid.page.js.map