"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var split_1 = require("@devexperts/utils/dist/string/split");
var pure_1 = require("../../utils/pure");
var withTheme_1 = require("../../utils/withTheme");
var with_defaults_1 = require("../../utils/with-defaults");
exports.HIGHLIGHT = Symbol('Mark');
var RawHighlight = /** @class */ (function (_super) {
    tslib_1.__extends(RawHighlight, _super);
    function RawHighlight() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RawHighlight.prototype.render = function () {
        var _a = this.props, search = _a.search, children = _a.children, theme = _a.theme;
        var result;
        if (this.props.search === '') {
            result = children;
        }
        else {
            var splitted = split_1.default(children, search, false);
            result = splitted.reduce(function (acc, el, i) {
                if (el.trim() !== '') {
                    acc.push(i % 2 ? (React.createElement("mark", { className: theme.mark, key: i }, el)) : (el));
                }
                return acc;
            }, []);
        }
        return React.createElement("span", { className: theme.container }, result);
    };
    RawHighlight = tslib_1.__decorate([
        pure_1.PURE
    ], RawHighlight);
    return RawHighlight;
}(React.Component));
exports.Highlight = withTheme_1.withTheme(exports.HIGHLIGHT)(with_defaults_1.withDefaults({
    search: '',
})(RawHighlight));
//# sourceMappingURL=Highlight.js.map