import * as React from 'react';
import { ReactElement, EventHandler, MouseEvent } from 'react';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
export declare type THoldableChildProps = {
    onMouseDown: EventHandler<MouseEvent<Element>>;
    onMouseUp: EventHandler<MouseEvent<Element>>;
    onMouseLeave: EventHandler<MouseEvent<Element>>;
};
export declare type TFullHoldableProps = {
    children: ReactElement<THoldableChildProps>;
    onHold: Function;
    delay: number;
    interval: number;
    isDisabled?: boolean;
};
export declare type THoldableProps = PartialKeys<TFullHoldableProps, 'delay' | 'interval'>;
export declare const Holdable: React.ComponentType<PartialKeys<TFullHoldableProps, "delay" | "interval">>;
