"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var pure_1 = require("../../utils/pure");
var classnames = require("classnames");
var withTheme_1 = require("../../utils/withTheme");
exports.LINK = Symbol('Link');
var RawLink = /** @class */ (function (_super) {
    tslib_1.__extends(RawLink, _super);
    function RawLink() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onClick = function (e) {
            if (_this.props.isDisabled || (!_this.props.processEmptyHash && _this.props.href === '#')) {
                e.preventDefault();
            }
            _this.props.onClick && _this.props.onClick(e);
        };
        return _this;
    }
    RawLink.prototype.render = function () {
        var _a;
        var _b = this.props, isDisabled = _b.isDisabled, rel = _b.rel, href = _b.href, target = _b.target, children = _b.children, theme = _b.theme, download = _b.download;
        var className = classnames(theme.container, (_a = {},
            _a[theme.container_isDisabled] = isDisabled,
            _a));
        return (React.createElement("a", { href: href, download: download, rel: rel, target: target, onClick: this.onClick, className: className }, children));
    };
    RawLink = tslib_1.__decorate([
        pure_1.PURE
    ], RawLink);
    return RawLink;
}(React.Component));
exports.Link = withTheme_1.withTheme(exports.LINK)(RawLink);
//# sourceMappingURL=Link.js.map