"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var Input_1 = require("../../input/Input");
var Popover_1 = require("../Popover");
var Popover_model_1 = require("../Popover.model");
var Control_1 = require("../../Control/Control");
var Demo_1 = require("../../demo/Demo");
var StatefulInput = Control_1.stateful()(Input_1.Input);
var InputWithPopoverPage = /** @class */ (function (_super) {
    tslib_1.__extends(InputWithPopoverPage, _super);
    function InputWithPopoverPage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.anchor = null;
        _this.state = {
            isOpened: false,
        };
        _this.onBlur = function () {
            _this.setState({ isOpened: true });
        };
        _this.onFocus = function () {
            _this.setState({ isOpened: false });
        };
        _this.onPopoverRequestClose = function () {
            _this.setState({ isOpened: false });
        };
        return _this;
    }
    InputWithPopoverPage.prototype.render = function () {
        var _this = this;
        var isOpened = this.state.isOpened;
        return (React.createElement(Demo_1.default, null,
            React.createElement("p", null, "Case when we have to show popover when losing focus on input"),
            React.createElement(StatefulInput, { defaultValue: 'input', onBlur: this.onBlur, onFocus: this.onFocus, ref: function (e) { return (_this.anchor = e); } }),
            isOpened && (React.createElement(Popover_1.Popover, { anchor: this.anchor, isOpened: true, closeOnClickAway: true, onRequestClose: this.onPopoverRequestClose, hasArrow: true, placement: Popover_model_1.PopoverPlacement.Bottom, align: Popover_model_1.PopoverAlign.Left },
                React.createElement("div", null, "popover content")))));
    };
    return InputWithPopoverPage;
}(React.PureComponent));
exports.InputWithPopoverPage = InputWithPopoverPage;
//# sourceMappingURL=InputWithPopover.page.js.map