"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_1 = require("react");
var EventListener_1 = require("../EventListener/EventListener");
var react_dom_1 = require("react-dom");
var Control_1 = require("../Control/Control");
var pure_1 = require("../../utils/pure");
var RootClose = /** @class */ (function (_super) {
    tslib_1.__extends(RootClose, _super);
    function RootClose() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.preventMouseRootClose = false;
        _this.ignoreMouseUp = true;
        _this.onMouseDown = function () {
            _this.ignoreMouseUp = false;
        };
        _this.handleClickCapture = function (e) {
            var domNode = react_dom_1.findDOMNode(_this);
            if (!domNode) {
                return;
            }
            _this.preventMouseRootClose =
                _this.ignoreMouseUp || isModifiedEvent(e) || !isLeftClickEvent(e) || domNode.contains(e.target);
        };
        _this.handleClick = function (e) {
            if (!_this.props.ignoreClick && !_this.preventMouseRootClose && _this.props.onRootClose) {
                _this.props.onRootClose();
            }
        };
        _this.handleTouchStartCapture = function (e) {
            var domNode = react_dom_1.findDOMNode(_this);
            if (!domNode) {
                return;
            }
            _this.preventMouseRootClose = domNode.contains(e.target);
        };
        _this.handleTouchStart = function () {
            if (!_this.props.ignoreClick && !_this.preventMouseRootClose && _this.props.onRootClose) {
                _this.props.onRootClose();
            }
        };
        _this.handleKeyUp = function (e) {
            if (!_this.props.ignoreKeyUp && e.keyCode === Control_1.KeyCode.Escape && _this.props.onRootClose) {
                _this.props.onRootClose();
            }
        };
        return _this;
    }
    RootClose.prototype.render = function () {
        return (React.createElement(EventListener_1.EventListener, { target: document, onMouseDown: this.onMouseDown, onClick: this.handleClick, onClickCapture: this.handleClickCapture, onTouchStart: this.handleTouchStart, onTouchStartCapture: this.handleTouchStartCapture, onKeyUp: this.handleKeyUp }, this.props.children));
    };
    RootClose = tslib_1.__decorate([
        pure_1.PURE
    ], RootClose);
    return RootClose;
}(react_1.Component));
exports.RootClose = RootClose;
function isLeftClickEvent(event) {
    return event.button === 0;
}
function isModifiedEvent(event) {
    return Boolean(event.metaKey || event.altKey || event.ctrlKey || event.shiftKey);
}
//# sourceMappingURL=RootClose.js.map