import * as React from 'react';
import { Scrollbar, TScrollbarProps } from './Scrollbar';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
export declare const VERTICAL_SCROLLBAR: symbol;
export declare type TAdditionalVerticalScrollBarProp = {
    scrollTop?: number;
};
export declare type TFullVerticalScrollBarProp = TScrollbarProps & TAdditionalVerticalScrollBarProp;
export declare class RawVerticalScrollbar extends Scrollbar<TAdditionalVerticalScrollBarProp> {
    _ratio: {
        size: number;
        position: number;
    };
    _previousDragCoordinate: number;
    _minBarSize: number;
    /**
     * @returns {Number}
     * @protected
     */
    _getMinBarSize(): number;
    /**
     * Hide native scroll
     * @private
     */
    _hideNativeScrollContainer(): void;
    componentDidMount(): void;
    componentWillReceiveProps(newProps: TFullVerticalScrollBarProp): void;
    _update(): void;
    _toggle(): void;
    _updateBar(): void;
    _getRatio(): {
        size: number;
        position: number;
    };
    _scrollTo: (position: number) => void;
    /**
     * @param {WheelEvent} event
     * @protected
     */
    onTrackMouseWheel: (event: React.WheelEvent<HTMLDivElement>) => void;
    /**
     * @param {MouseEvent} event
     * @protected
     */
    onTrackClick: (event: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
    /**
     * @param {MouseEvent} event
     * @protected
     */
    onBarDragStart: (event: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
    /**
     * @param {MouseEvent} event
     * @protected
     */
    onBarDrag: (event: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
}
export declare type TVerticalScrollbarProps = PartialKeys<TFullVerticalScrollBarProp, 'theme'>;
export declare const VerticalScrollbar: React.ComponentClass<TVerticalScrollbarProps>;
