import * as React from 'react';
import { TSelectboxAnchorProps } from './SelectboxAnchor';
import { TPopoverProps } from '../Popover/Popover';
import { TMenuItemProps, TMenuProps } from '../Menu/Menu';
import { ComponentClass, ComponentType, ReactElement, ReactNode, ReactText } from 'react';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
import { TControlProps } from '../Control/Control';
export declare const SELECTBOX: symbol;
export declare type SelectboxValue = ReactText | ReactText[] | undefined;
declare type SelectboxChildren = ReactElement<TMenuItemProps>[] | ReactElement<TMenuItemProps>;
export declare type TFullSelectboxProps = TControlProps<SelectboxValue> & TControlProps<boolean | undefined, 'isOpened', 'onToggle'> & {
    theme: {
        container_isOpened?: string;
        container__popover?: string;
        container__popover__content?: string;
        container__menu?: string;
        container__menu_hasSelectedItem?: string;
        container__item?: string;
        container__item_isActive?: string;
        container__item__text?: string;
        container__item__activeIcon?: string;
        container__anchor?: string;
        container__anchor__content?: string;
        container__anchor__text?: string;
        container__anchor__content_hasCaret?: string;
        container__anchor__wrapperCaret?: string;
        container__anchor__caret?: string;
        container__anchor__caret_isReversed?: string;
    };
    multipleFormatter?: (value: ReactText[]) => ReactNode;
    children: SelectboxChildren;
    isDisabled?: boolean;
    isLoading?: boolean;
    placeholder?: string;
    Anchor: ComponentClass<TSelectboxAnchorProps>;
    Menu: ComponentType<TMenuProps>;
    Popover: ComponentType<TPopoverProps>;
    caretIcon?: React.ReactElement<any> | React.ReactText;
    selectedIcon?: React.ReactElement<any> | React.ReactText;
    shouldSyncWidth?: boolean;
};
export declare type TSelectboxProps = PartialKeys<TFullSelectboxProps, 'theme' | 'Anchor' | 'Menu' | 'Popover'>;
export declare const Selectbox: ComponentClass<TSelectboxProps>;
export {};
