"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_1 = require("@storybook/react");
var Demo_1 = require("../demo/Demo");
var Button_1 = require("../Button/Button");
var Selectbox_1 = require("./Selectbox");
var SelectboxAnchor_1 = require("./SelectboxAnchor");
var Menu_1 = require("../Menu/Menu");
var pure_1 = require("../../utils/pure");
var list_item_tick_icon_1 = require("../../icons/list-item-tick-icon");
var small_dropdown_arrow_icon_1 = require("../../icons/small-dropdown-arrow-icon");
var Control_1 = require("../Control/Control");
var selectoxPageCss = require("./Selectbox.page.styl");
var wideSelectboxTheme = {
    container__anchor: selectoxPageCss.container__anchor,
};
var DemoSelectboxAnchor = /** @class */ (function (_super) {
    tslib_1.__extends(DemoSelectboxAnchor, _super);
    function DemoSelectboxAnchor() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DemoSelectboxAnchor.prototype.render = function () {
        var newProps = tslib_1.__assign(tslib_1.__assign({}, this.props), { isPrimary: true });
        return React.createElement(SelectboxAnchor_1.SelectboxAnchor, tslib_1.__assign({}, newProps));
    };
    return DemoSelectboxAnchor;
}(React.Component));
var DemoSelectbox = /** @class */ (function (_super) {
    tslib_1.__extends(DemoSelectbox, _super);
    function DemoSelectbox() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DemoSelectbox.prototype.render = function () {
        var newProps = tslib_1.__assign(tslib_1.__assign({}, this.props), { AnchorComponent: DemoSelectboxAnchor, caretIcon: React.createElement(small_dropdown_arrow_icon_1.SmallDropDownArrowIcon, null) });
        return React.createElement(Selectbox_1.Selectbox, tslib_1.__assign({}, newProps));
    };
    return DemoSelectbox;
}(React.Component));
var Stateful = Control_1.stateful()(DemoSelectbox);
var StatefulOpened = Control_1.stateful('isOpened', 'onToggle')(Stateful);
var SelectboxPage = /** @class */ (function (_super) {
    tslib_1.__extends(SelectboxPage, _super);
    function SelectboxPage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            hero: '',
            isFirstSelectboxOpened: false,
            isSecondSelectboxOpened: false,
            isThirdSelectboxOpened: false,
            isFoughtSelectboxOpened: false,
        };
        _this.onHeroChange = function (hero) {
            _this.setState({
                hero: hero,
            });
        };
        _this.onResetClick = function () {
            _this.setState({
                hero: '',
            });
        };
        _this.onFirstSelectboxToggle = function (isFirstSelectboxOpened) {
            _this.setState({
                isFirstSelectboxOpened: isFirstSelectboxOpened,
            });
        };
        _this.onSecondSelectboxToggle = function (isSecondSelectboxOpened) {
            _this.setState({
                isSecondSelectboxOpened: isSecondSelectboxOpened,
            });
        };
        _this.onThirdSelectboxToggle = function (isThirdSelectboxOpened) {
            _this.setState({
                isThirdSelectboxOpened: isThirdSelectboxOpened,
            });
        };
        _this.onFoughtSelectboxToggle = function (isFoughtSelectboxOpened) {
            _this.setState({
                isFoughtSelectboxOpened: isFoughtSelectboxOpened,
            });
        };
        return _this;
    }
    SelectboxPage.prototype.render = function () {
        return (React.createElement(Demo_1.default, null,
            React.createElement("div", null,
                React.createElement(Stateful, { defaultValue: undefined, placeholder: "Choose your hero", isOpened: this.state.isFirstSelectboxOpened, onToggle: this.onFirstSelectboxToggle, selectedIcon: React.createElement(list_item_tick_icon_1.ListItemTickIcon, null), onValueChange: this.onHeroChange, caretIcon: React.createElement(small_dropdown_arrow_icon_1.SmallDropDownArrowIcon, null) },
                    React.createElement(Menu_1.MenuItem, { value: "superman" }, "Superman"),
                    React.createElement(Menu_1.MenuItem, { value: "batman" }, "Batman"),
                    React.createElement(Menu_1.MenuItem, { value: "flash" }, "Flash")),
                React.createElement(DemoSelectbox, { placeholder: "Controlled by left", value: this.state.hero, theme: {}, isOpened: this.state.isSecondSelectboxOpened, onToggle: this.onSecondSelectboxToggle, selectedIcon: React.createElement(list_item_tick_icon_1.ListItemTickIcon, null), onValueChange: this.onHeroChange, caretIcon: React.createElement(small_dropdown_arrow_icon_1.SmallDropDownArrowIcon, null) },
                    React.createElement(Menu_1.MenuItem, { value: "superman" }, "Superman"),
                    React.createElement(Menu_1.MenuItem, { value: "batman" }, "Batman"),
                    React.createElement(Menu_1.MenuItem, { value: "flash" }, "Flash")),
                React.createElement(Stateful, { defaultValue: undefined, placeholder: "Loading", isOpened: this.state.isThirdSelectboxOpened, onToggle: this.onThirdSelectboxToggle, isDisabled: true, isLoading: true },
                    React.createElement(Menu_1.MenuItem, { value: "dummy" }, "Dummy")),
                React.createElement(Button_1.Button, { onClick: this.onResetClick }, "Reset")),
            React.createElement("section", null,
                "Sync width",
                React.createElement(Stateful, { defaultValue: undefined, placeholder: "Choose your hero", isOpened: this.state.isFoughtSelectboxOpened, onToggle: this.onFoughtSelectboxToggle, shouldSyncWidth: true, theme: wideSelectboxTheme, selectedIcon: React.createElement(list_item_tick_icon_1.ListItemTickIcon, null), caretIcon: React.createElement(small_dropdown_arrow_icon_1.SmallDropDownArrowIcon, null) },
                    React.createElement(Menu_1.MenuItem, { value: "batman" }, "Batman"),
                    React.createElement(Menu_1.MenuItem, { value: "superman" }, "Superman"),
                    React.createElement(Menu_1.MenuItem, { value: "flash" }, "Flash"))),
            React.createElement("section", null,
                "Uncontrolled by isOpened",
                React.createElement(StatefulOpened, { defaultValue: undefined, placeholder: "Choose your hero", shouldSyncWidth: true, theme: wideSelectboxTheme, selectedIcon: React.createElement(list_item_tick_icon_1.ListItemTickIcon, null), caretIcon: React.createElement(small_dropdown_arrow_icon_1.SmallDropDownArrowIcon, null) },
                    React.createElement(Menu_1.MenuItem, { value: "superman" }, "Superman"),
                    React.createElement(Menu_1.MenuItem, { value: "batman" }, "Batman"),
                    React.createElement(Menu_1.MenuItem, { value: "flash" }, "Flash")))));
    };
    SelectboxPage = tslib_1.__decorate([
        pure_1.PURE
    ], SelectboxPage);
    return SelectboxPage;
}(React.Component));
var SelectboMultiplePage = /** @class */ (function (_super) {
    tslib_1.__extends(SelectboMultiplePage, _super);
    function SelectboMultiplePage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            isOpened: false,
        };
        _this.onValueChange = function (value) {
            _this.setState({
                value: value,
            });
        };
        _this.onToggle = function (isOpened) {
            _this.setState({
                isOpened: isOpened,
            });
        };
        return _this;
    }
    SelectboMultiplePage.prototype.render = function () {
        var multipleFormatter = this.props.multipleFormatter;
        return (React.createElement(Demo_1.default, null,
            React.createElement(Stateful, { defaultValue: ['superman', 'batman'], placeholder: "Choose your hero", multipleFormatter: multipleFormatter, isOpened: this.state.isOpened, onToggle: this.onToggle, selectedIcon: React.createElement(list_item_tick_icon_1.ListItemTickIcon, null), onValueChange: this.onValueChange, caretIcon: React.createElement(small_dropdown_arrow_icon_1.SmallDropDownArrowIcon, null) },
                React.createElement(Menu_1.MenuItem, { value: "superman" }, "Superman"),
                React.createElement(Menu_1.MenuItem, { value: "batman" }, "Batman"),
                React.createElement(Menu_1.MenuItem, { value: "flash" }, "Flash"))));
    };
    SelectboMultiplePage = tslib_1.__decorate([
        pure_1.PURE
    ], SelectboMultiplePage);
    return SelectboMultiplePage;
}(React.Component));
react_1.storiesOf('Selectbox', module)
    .add('default', function () { return React.createElement(SelectboxPage, null); })
    .add('multiple', function () { return (React.createElement(Demo_1.default, null,
    React.createElement(SelectboMultiplePage, null))); })
    .add('multiple formatter', function () { return (React.createElement(Demo_1.default, null,
    React.createElement(SelectboMultiplePage, { multipleFormatter: function (value) { return "Selected " + value.length + " item"; } }))); });
//# sourceMappingURL=Selectbox.page.js.map