import { ComponentClass, ComponentType, ReactElement } from 'react';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
import { TButtonIconProps } from '../ButtonIcon/ButtonIcon';
import { TInputProps } from '../input/Input';
import { ReactRef } from '../../utils/typings';
export declare const STEPPABLE_INPUT: symbol;
export declare type TPickedInputProps = Pick<TInputProps, 'error' | 'onBlur' | 'onFocus' | 'onKeyDown' | 'onClick' | 'onMouseEnter' | 'onMouseLeave'>;
export declare type TFullSteppableInputProps = TPickedInputProps & {
    isDisabled?: TInputProps['isDisabled'];
    isIncrementButtonDisabled?: boolean;
    isDecrementButtonDisabled?: boolean;
    tabIndex?: number;
    onIncrement?: Function;
    onDecrement?: Function;
    onClear?: Function;
    incrementIcon?: ReactElement<any>;
    decrementIcon?: ReactElement<any>;
    clearIcon?: ReactElement<any>;
    innerRef?: (instance: ReactRef) => void;
    children?: any;
    Input: ComponentType<TInputProps>;
    ButtonIcon: ComponentType<TButtonIconProps>;
    theme: {
        inner?: string;
        Input?: TInputProps['theme'];
        ButtonIcon?: TButtonIconProps['theme'];
        ClearButtonIcon?: TButtonIconProps['theme'];
    };
};
export declare type TSteppableInputProps = PartialKeys<TFullSteppableInputProps, 'theme' | 'Input' | 'ButtonIcon'>;
export declare const SteppableInput: ComponentClass<TSteppableInputProps>;
export declare function checkParentsUpTo(node?: Element | null, checkNode?: Element, upToNode?: Element): boolean;
