"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var ReactDOM = require("react-dom");
var react_1 = require("@storybook/react");
var addon_actions_1 = require("@storybook/addon-actions");
var pageTheme = require("./theme/SteppableInput.page.styl");
var add_icon_1 = require("../../icons/add-icon");
var decrease_icon_1 = require("../../icons/decrease-icon");
var small_cross_icon_1 = require("../../icons/small-cross-icon");
var SteppableInput_1 = require("./SteppableInput");
var Demo_1 = require("../demo/Demo");
var DemoInput = /** @class */ (function (_super) {
    tslib_1.__extends(DemoInput, _super);
    function DemoInput() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onFocus = function (e) {
            var input = ReactDOM.findDOMNode(_this.input);
            input.focus();
        };
        return _this;
    }
    DemoInput.prototype.render = function () {
        var _this = this;
        var _a = this.props, onIncrement = _a.onIncrement, onDecrement = _a.onDecrement, error = _a.error, onClear = _a.onClear, isDisabled = _a.isDisabled;
        return (React.createElement("div", null,
            React.createElement(SteppableInput_1.SteppableInput, { onIncrement: onIncrement, onDecrement: onDecrement, onClear: onClear, error: error, onFocus: this.onFocus, clearIcon: React.createElement(small_cross_icon_1.SmallCrossIcon, null), decrementIcon: React.createElement(decrease_icon_1.DecreaseIcon, null), incrementIcon: React.createElement(add_icon_1.AddIcon, null), isDisabled: isDisabled },
                React.createElement("input", { className: pageTheme.customInput, tabIndex: -1, disabled: isDisabled, ref: function (el) { return (_this.input = el); } }))));
    };
    return DemoInput;
}(React.Component));
react_1.storiesOf('SteppableInput', module).add('default', function () {
    return (React.createElement(Demo_1.Demo, null,
        React.createElement(DemoInput, { onIncrement: addon_actions_1.action('increment'), onDecrement: addon_actions_1.action('decremnt') }),
        React.createElement(DemoInput, { onClear: addon_actions_1.action('clear') }),
        React.createElement(DemoInput, { onIncrement: addon_actions_1.action('increment'), isDisabled: true, onDecrement: addon_actions_1.action('decremnt'), onClear: addon_actions_1.action('clear') }),
        React.createElement(DemoInput, { onIncrement: addon_actions_1.action('increment'), onDecrement: addon_actions_1.action('decremnt'), onClear: addon_actions_1.action('clear') }),
        React.createElement(DemoInput, { onIncrement: addon_actions_1.action('increment'), onDecrement: addon_actions_1.action('decremnt'), error: 'Error', onClear: addon_actions_1.action('clear') })));
});
//# sourceMappingURL=SteppableInput.page.js.map