"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var react_1 = require("@storybook/react");
var addon_actions_1 = require("@storybook/addon-actions");
var TimeInput_1 = require("./TimeInput");
var Demo_1 = require("../demo/Demo");
var Button_1 = require("../Button/Button");
var add_icon_1 = require("../../icons/add-icon");
var decrease_icon_1 = require("../../icons/decrease-icon");
var small_cross_icon_1 = require("../../icons/small-cross-icon");
var Option_1 = require("fp-ts/lib/Option");
var TimeInput_model_1 = require("./TimeInput.model");
var time = {
    hours: Option_1.some(1),
    minutes: Option_1.some(20),
    seconds: Option_1.some(35),
    periodType: Option_1.some(TimeInput_model_1.PeriodType.AM),
};
var log = addon_actions_1.action('change');
var TimeInputPage = /** @class */ (function (_super) {
    tslib_1.__extends(TimeInputPage, _super);
    function TimeInputPage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            value: time,
        };
        _this.onTimeInputChange = function (value) {
            log(value);
            _this.setState({ value: value });
        };
        _this.onClearClick = function () {
            _this.setState({
                value: {
                    hours: Option_1.none,
                    minutes: Option_1.none,
                    seconds: Option_1.none,
                    periodType: Option_1.none,
                },
            });
        };
        return _this;
    }
    TimeInputPage.prototype.render = function () {
        var withSeconds = this.props.withSeconds;
        return (React.createElement(Demo_1.Demo, null,
            withSeconds && React.createElement("input", { type: "time", id: "time", step: "1" }),
            !withSeconds && React.createElement("input", { type: "time", id: "time" }),
            React.createElement("div", null,
                React.createElement(TimeInput_1.TimeInput, { withPeriodType: this.props.withPeriodType, withSeconds: this.props.withSeconds, decrementIcon: React.createElement(decrease_icon_1.DecreaseIcon, null), isDisabled: this.props.isDisabled, incrementIcon: React.createElement(add_icon_1.AddIcon, null), error: this.props.error, clearIcon: React.createElement(small_cross_icon_1.SmallCrossIcon, null), onValueChange: this.onTimeInputChange, value: this.state.value }),
                React.createElement(Button_1.Button, { onClick: this.onClearClick }, "clear"))));
    };
    return TimeInputPage;
}(React.Component));
react_1.storiesOf('TimeInput', module)
    .add('default', function () { return React.createElement(TimeInputPage, null); })
    .add('disabled', function () { return React.createElement(TimeInputPage, { isDisabled: true }); })
    .add('invalid', function () { return React.createElement(TimeInputPage, { error: true }); })
    .add('With seconds only', function () { return React.createElement(TimeInputPage, { withSeconds: true }); })
    .add('With period type only ', function () { return React.createElement(TimeInputPage, { withPeriodType: true }); })
    .add('With seconds and period type', function () { return React.createElement(TimeInputPage, { withSeconds: true, withPeriodType: true }); });
//# sourceMappingURL=TimeInput.page.js.map