import * as React from 'react';
import { ItemSide, LAYOUT_THEME, TLayoutStructure, TMinimumLayoutModelItemProps } from './layout.constants';
declare type TPlaceholderProps = {
    className?: string;
    fits?: boolean;
    isFull?: boolean;
    isMaximized?: boolean;
    side?: ItemSide;
};
declare type TOwnLayoutProps<P extends TMinimumLayoutModelItemProps> = {
    value: TLayoutStructure<P>;
    onChange?: (value: TLayoutStructure<P>) => any;
    debounceResize?: number;
    theme: LAYOUT_THEME;
    maximizedId?: string;
    ItemComponent: any;
};
declare type TDefaultLayoutProps<P extends TMinimumLayoutModelItemProps> = {
    Scrollable: React.ComponentClass<any>;
    Placeholder: React.ComponentClass<TPlaceholderProps> | React.SFC<TPlaceholderProps>;
    itemPropsFactory: (data: unknown) => P;
    resizeHandlerSize: number;
    minItemWidth: number;
    minItemHeight: number;
    isFixed: boolean;
};
declare type TFullLayoutProps<P extends TMinimumLayoutModelItemProps> = TOwnLayoutProps<P> & TDefaultLayoutProps<P>;
declare type TLayoutDefaults = 'isFixed' | 'Placeholder' | 'Scrollable';
export declare const Layout: React.ComponentClass<import("@devexperts/utils/dist/object/object").PartialKeys<Pick<TFullLayoutProps<TMinimumLayoutModelItemProps>, "theme" | "value" | "onChange" | "resizeHandlerSize" | "minItemWidth" | "minItemHeight" | "maximizedId" | "itemPropsFactory" | "ItemComponent" | "debounceResize"> & Partial<Pick<TFullLayoutProps<TMinimumLayoutModelItemProps>, TLayoutDefaults>> & {
    withRef?: ((instance: any) => void) | React.RefObject<any> | null | undefined;
}, "theme">, any>;
export {};
