import { ItemSide, LayoutOrientation, ResizeHandlerSide, TDenormalizedLayout, TLayoutItem, TLayoutModelLayout, TLayoutStructure, TMinimumLayoutModelItemProps } from './layout.constants';
export declare function fixFloatSizes(sizes: number[], sum: number, precision: number): number[];
export declare type TPlaceholderPlacement = {
    side?: ItemSide;
    fits: boolean;
};
export declare function getPlaceholderPlacement(x1: number, y1: number, x2: number, y2: number, x: number, y: number, minWidth: number, minHeight: number, isMaximized: boolean): TPlaceholderPlacement;
export declare function invalidateParents<P extends TMinimumLayoutModelItemProps>(items: Record<string, TLayoutItem<P>>, fromId: string): Record<string, TLayoutItem<P>>;
export declare function generateWrapperLayout(id: string, destination: TLayoutItem<TMinimumLayoutModelItemProps>, parent: TLayoutModelLayout, side: ItemSide): TLayoutModelLayout;
export declare function flattenLayoutItems<P extends TMinimumLayoutModelItemProps>(items: Record<string, TLayoutItem<P>>, fromId: string): Record<string, TLayoutItem<P>>;
export declare function normalizeLayout<P extends TMinimumLayoutModelItemProps>(data: TDenormalizedLayout<P>): TLayoutStructure<P>;
export declare function denormalizeLayout<P extends TMinimumLayoutModelItemProps>(layout: TLayoutStructure<P>): TDenormalizedLayout<P>;
export declare function getDefaultChildrenSizes(layout: TLayoutStructure<TMinimumLayoutModelItemProps>, item: TLayoutModelLayout, containerSize: number, precision: number): number[];
export declare function setDefaults<P extends TMinimumLayoutModelItemProps>(layout: TLayoutStructure<P>): TLayoutStructure<P>;
export declare function prepareLayout<P extends TMinimumLayoutModelItemProps>(layout: TDenormalizedLayout<P>): TLayoutStructure<P>;
export declare function getResizeHandlerSide(sizes: Array<number>, index: number): ResizeHandlerSide | undefined;
export declare function setTransferData(event: DragEvent, data: {}): void;
export declare function setDragData<P>(event: DragEvent, data: P): void;
export declare function countChildren<P extends TMinimumLayoutModelItemProps>(layout: TLayoutStructure<P>, item: TLayoutItem<P>, orientation: LayoutOrientation): number;
export declare function chooseByOrientation<H, V>(horizontal: H, vertical: V, orientation: LayoutOrientation): H | V;
export declare type TSize = {
    width: number;
    height: number;
};
export declare type TSizeMap = {
    [itemId: string]: TSize;
};
export declare function getSizeMap<P extends TMinimumLayoutModelItemProps>(layout: TLayoutStructure<P>, item: TLayoutItem<P>, defaultMinWidth: number, defaultMinHeight: number, width: number, height: number, resizeHandlerSize: number, precision: number, ignoreId?: string, acc?: TSizeMap): TSizeMap;
export declare function normalizeSizes(sizes: number[], containerSize: number, precision: number): number[];
export declare function isEmptyRoot(layout: TLayoutStructure<TMinimumLayoutModelItemProps>, item: TLayoutModelLayout): boolean;
export declare function getMinWidth(item: TLayoutItem<TMinimumLayoutModelItemProps>, defaultMinWidth: number): number;
export declare function getMinHeight(item: TLayoutItem<TMinimumLayoutModelItemProps>, defaultMinHeight: number): number;
