"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var React = require("react");
var prefix_1 = require("@devexperts/utils/dist/dom/prefix");
var react_draggable_1 = require("react-draggable");
var layout_constants_1 = require("./layout.constants");
var pure_1 = require("../../utils/pure");
var with_defaults_1 = require("../../utils/with-defaults");
var RawResizeHandler = /** @class */ (function (_super) {
    tslib_1.__extends(RawResizeHandler, _super);
    function RawResizeHandler() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.onDragStart = function (e, data) {
            var onDragStart = _this.props.onDragStart;
            if (onDragStart) {
                var _a = _this.props, previousId = _a.previousId, nextId = _a.nextId;
                onDragStart(previousId, nextId, e, data);
            }
        };
        return _this;
    }
    RawResizeHandler.prototype.render = function () {
        var _a = this.props, theme = _a.theme, onDrag = _a.onDrag, onDragStop = _a.onDragStop, onMouseDown = _a.onMouseDown, offset = _a.offset, size = _a.size, isFixed = _a.isFixed, orientation = _a.orientation;
        var style = getSizeStyle(orientation, offset, size);
        if (isFixed) {
            return React.createElement("div", { style: style, className: theme.resizeHandler + " " + theme.resizeHandler_disabled });
        }
        return (React.createElement(react_draggable_1.DraggableCore, { enableUserSelectHack: false, onMouseDown: onMouseDown, onDrag: onDrag, onStart: this.onDragStart, onStop: onDragStop },
            React.createElement("div", { style: style, className: theme.resizeHandler })));
    };
    RawResizeHandler.defaultProps = {
        offset: 0,
        theme: {},
    };
    RawResizeHandler = tslib_1.__decorate([
        pure_1.PURE
    ], RawResizeHandler);
    return RawResizeHandler;
}(React.Component));
function getSizeStyle(orientation, offset, size) {
    switch (orientation) {
        case layout_constants_1.LayoutOrientation.Horizontal: {
            return tslib_1.__assign(tslib_1.__assign({}, prefix_1.default({
                transform: "translateX(" + offset + "px)",
            })), { width: size });
        }
        case layout_constants_1.LayoutOrientation.Vertical: {
            return tslib_1.__assign(tslib_1.__assign({}, prefix_1.default({
                transform: "translateY(" + offset + "px)",
            })), { height: size });
        }
    }
}
exports.ResizeHandler = with_defaults_1.withDefaults({
    offset: 0,
    theme: {},
})(RawResizeHandler);
//# sourceMappingURL=resize-handler.component.js.map