import * as React from 'react';
import { PartialKeys } from '@devexperts/utils/dist/object/object';
export declare type TTheme = {
    [key: string]: TTheme | string | undefined;
};
declare type TTargetProps = {
    theme?: TTheme;
};
export declare const withTheme: (name: string | symbol, defaultTheme?: TTheme) => <P extends TTargetProps>(Target: React.ComponentType<P>) => React.ComponentClass<PartialKeys<P & {
    withRef?: ((instance: any) => void) | React.RefObject<any> | null | undefined;
}, "theme">, any>;
/**
 * Merges passed themes by concatenating string keys and processing nested themes
 */
export declare function mergeThemes(...themes: TTheme[]): TTheme;
export declare type TThemeProviderProps = {
    theme: {
        [key: string]: TTheme;
    };
};
export declare class ThemeProvider extends React.Component<TThemeProviderProps> {
    static childContextTypes: {
        [x: string]: () => null;
    };
    render(): string | number | boolean | {} | React.ReactElement<any, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)> | React.ReactPortal | null | undefined;
    getChildContext(): {
        [x: string]: {
            [key: string]: TTheme;
        };
    };
}
export {};
